registerInputEvent("FxDTSBrick","onPlayerStopTouch","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");

datablock TriggerData(onPlayerStopTouchTriggerData)
{
	tickPeriodMS = 150;
};

function onPlayerStopTouchTriggerData::onLeaveTrigger(%this, %trigger, %obj)
{
	if(%obj.getClassName !$= "Player")
	{
		return;
	}

	$InputTarget_["Self"] = %trigger.brick;
	$InputTarget_["Player"] = %obj;
	$InputTarget_["Client"] = %obj.client;

	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
	}

	else
	{
		if(getMiniGameFromObject(%this) == getMiniGameFromObject(%obj.client))
		{
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
		}

		else
		{
			$InputTarget_["MiniGame"] = 0;
		}
	}

	%trigger.brick.processInputEvent(onPlayerStopTouch, %obj.client);
}

function FxDTSBrick::createTrigger(%this, %data)
{
	//credits to Space Guy for showing how to create triggers

	%t = new Trigger()
	{
		datablock = %data;
		polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1"; //this determines the shape of the trigger
	};

	missionCleanup.add(%t);
	
	%boxMax = getWords(%this.getWorldBox(), 3, 5);
	%boxMin = getWords(%this.getWorldBox(), 0, 2);
	%boxDiff = vectorSub(%boxMax,%boxMin);
	%boxDiff = vectorAdd(%boxDiff, "0 0 0.2"); 
	%t.setScale(%boxDiff);
	%posA = %this.getWorldBoxCenter();
	%posB = %t.getWorldBoxCenter();
	%posDiff = vectorSub(%posA, %posB);
	%posDiff = vectorAdd(%posDiff, "0 0 0.1");
	%t.setTransform(%posDiff);

	%this.trigger = %t;
	%t.brick = %this;

	return %t;
}

package onPlayerStopTouch
{
	function FxDTSBrick::onPlayerTouch(%obj, %player)
	{
		if(!isObject(%obj.trigger))
		{
			%obj.createTrigger(onPlayerStopTouchTriggerData);
		}
		
		return parent::onPlayerTouch(%obj, %player);
	}

	function FxDTSBrick::onRemove(%brick)
	{
		if(isObject(%brick.trigger))
		{
			%brick.trigger.delete();
		}

		parent::onRemove(%brick);
	}
};
activatePackage(onPlayerStopTouch);